//
// BwgBurn - CD-R/CD-RW/DVD-R/DVD-RW burning program for Windows XP
// 
// Copyright (C) 2006 by Jack W. Griffin (butchg@comcast.net)
//
// This program is free software; you can redistribute it and/or modify 
// it under the terms of the GNU General Public License as published by 
// the Free Software Foundation; either version 2 of the License, or 
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but 
// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
// or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
// for more details.
//
// You should have received a copy of the GNU General Public License along 
// with this program; if not, write to the 
//
// Free Software Foundation, Inc., 
// 59 Temple Place, Suite 330, 
// Boston, MA 02111-1307 USA
//

using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices ;

namespace Bwg.Audio.Acm
{
    class AcmDataBuffer : IDisposable
    {
        public int DataConsumed;
        public int DataSize;
        public IntPtr DataBuffer;

        public AcmDataBuffer(int size)
        {
            DataSize = size ;
            DataBuffer = Marshal.AllocHGlobal((int)size) ;
            DataConsumed = 0;
        }

        public int DataRemaining
        {
            get
            {
                return DataSize - DataConsumed;
            }
        }

        public void CopyTo(IntPtr data, int off, int len)
        {
            IntPtr ptr = new IntPtr(DataBuffer.ToInt32() + DataConsumed);
            IntPtr dest = new IntPtr(data.ToInt32() + off);
            AcmInterface.RtlMoveMemory(dest, ptr, len);
            DataConsumed += len;
        }

        public void Dispose()
        {
            Marshal.FreeHGlobal(DataBuffer);
        }
    }
}
