//
// BwgBurn - CD-R/CD-RW/DVD-R/DVD-RW burning program for Windows XP
// 
// Copyright (C) 2006 by Jack W. Griffin (butchg@comcast.net)
//
// This program is free software; you can redistribute it and/or modify 
// it under the terms of the GNU General Public License as published by 
// the Free Software Foundation; either version 2 of the License, or 
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but 
// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
// or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
// for more details.
//
// You should have received a copy of the GNU General Public License along 
// with this program; if not, write to the 
//
// Free Software Foundation, Inc., 
// 59 Temple Place, Suite 330, 
// Boston, MA 02111-1307 USA
//
using System;
using System.Collections.Generic;
using System.Text;
using Bwg.Utils ;

namespace Bwg.Audio.Acm
{
    public class AcmFileSource : AcmDataSource
    {
        #region private data members
        /// <summary>
        /// The name of the file to read
        /// </summary>
        private string m_filename;

        /// <summary>
        /// The position in the file for the data
        /// </summary>
        private long m_data_position;

        /// <summary>
        /// The reader for reading data from a file
        /// </summary>
        private OsFileReader m_reader;

        #endregion

        #region constructors
        public AcmFileSource()
        {
            m_reader = new OsFileReader();
        }
        #endregion

        #region public methods
        public bool Open(string name, long pos)
        {
            m_filename = name;
            m_data_position = pos;
            if (!m_reader.Open(name))
                return false;

            return m_reader.Seek(pos, OsFileReader.SeekType.Begin);
        }

        public override bool Read(IntPtr ptr, int requested, out int actual)
        {
            return m_reader.ReadData(ptr, requested, out actual);
        }

        public override bool Rewind()
        {
            return m_reader.Seek(m_data_position, OsFileReader.SeekType.Begin);
        }


        #endregion

        #region public properties
        /// <summary>
        /// The position of the data source within the file
        /// </summary>
        public long FilePosition
        {
            get
            {
                return m_reader.Position;
            }
        }
        #endregion
    }
}
