//
// BwgBurn - CD-R/CD-RW/DVD-R/DVD-RW burning program for Windows XP
// 
// Copyright (C) 2006 by Jack W. Griffin (butchg@comcast.net)
//
// This program is free software; you can redistribute it and/or modify 
// it under the terms of the GNU General Public License as published by 
// the Free Software Foundation; either version 2 of the License, or 
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but 
// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
// or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
// for more details.
//
// You should have received a copy of the GNU General Public License along 
// with this program; if not, write to the 
//
// Free Software Foundation, Inc., 
// 59 Temple Place, Suite 330, 
// Boston, MA 02111-1307 USA
//

using System;
using System.Collections.Generic;
using System.Text;

namespace Bwg.Audio.Acm
{
    public class AcmFormatDetails
    {
        private string m_name;
        private AcmInterface.WaveFormat m_tag;
        private IntPtr m_wave_format_ex;

        public AcmFormatDetails(string name, AcmInterface.WaveFormat tag, IntPtr ptr)
        {
            m_name = name;
            m_tag = tag;
            m_wave_format_ex = ptr;
        }

        public override string ToString()
        {
            string str;

            switch (m_tag)
            {
                case AcmInterface.WaveFormat.WAVE_FORMAT_PCM:
                    str = "Wave";
                    break;

                case AcmInterface.WaveFormat.WAVE_FORMAT_MPEGLAYER3:
                    str = "MP3";
                    break;

                case AcmInterface.WaveFormat.WAVE_FORMAT_MSAUDIO1:
                    str = "Windows Media V1";
                    break;

                case AcmInterface.WaveFormat.WAVE_FORMAT_MSAUDIO2:
                    str = "Windows Media V2";
                    break;

                default:
                    str = m_tag.ToString();
                    break;
            }
            str += ", " + m_name;
            return str;
        }

        public string Name
        {
            get
            {
                return m_name;
            }
        }

        public AcmInterface.WaveFormat Tag
        {
            get
            {
                return m_tag;
            }
        }

        public IntPtr WaveFormatExPtr
        {
            get
            {
                return m_wave_format_ex;
            }
        }
    }
}
