//
// BwgBurn - CD-R/CD-RW/DVD-R/DVD-RW burning program for Windows XP
// 
// Copyright (C) 2006 by Jack W. Griffin (butchg@comcast.net)
//
// This program is free software; you can redistribute it and/or modify 
// it under the terms of the GNU General Public License as published by 
// the Free Software Foundation; either version 2 of the License, or 
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but 
// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
// or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
// for more details.
//
// You should have received a copy of the GNU General Public License along 
// with this program; if not, write to the 
//
// Free Software Foundation, Inc., 
// 59 Temple Place, Suite 330, 
// Boston, MA 02111-1307 USA
//
using System;
using System.Collections.Generic;
using System.Text;

namespace Bwg.Audio
{
    public abstract class AudioWriter
    {
        #region standard song properties
        //
        // We primarily use the ID3 tags as keys
        //
        public const string PropNameSongTitle = "TIT2";
        public const string PropNameSongArtist = "TPE1";
        public const string PropNameTrackNumber = "TRCK";
        public const string PropNameYear = "TYER";
        public const string PropNamePublisher = "TPUB";
        public const string PropNameArtist = "TPE1";
        public const string PropNameContentType = "TCON";
        public const string PropNameAlbum = "TALB";

        #endregion

        #region public properties
        /// <summary>
        /// This property returns a human readable describing the type of the file.  This should
        /// be something like "MP3 File" or "WAV File"
        /// </summary>
        public abstract string FileTypeString
        {
            get;
        }
        #endregion

        #region constructors
        public AudioWriter()
        {
        }
        #endregion

        #region public methods
        public abstract bool Write(string filename);

        public abstract bool Close();
        #endregion
    }
}
