using System;
using System.Collections.Generic;
using System.Text;

namespace Bwg.Burner
{
    /// <summary>
    /// This abstract class represents the data assocaited with a CD text field.
    /// </summary>
    [Serializable()]
    public abstract class CDTextData
    {
        #region constructor
        /// <summary>
        /// Create a CD text data field
        /// </summary>
        public CDTextData()
        {
        }
        #endregion

        #region public functions
        /// <summary>
        /// This property returns the length of the data element in bytes
        /// </summary>
        public abstract int DataLength
        {
            get;
        }

        /// <summary>
        /// This property returns a byte array representing the data element
        /// </summary>
        public abstract byte[] Data
        {
            get;
        }

        /// <summary>
        /// Add data to the existing data element
        /// </summary>
        /// <param name="pos">the position of the data in the data stream</param>
        /// <param name="data">the data</param>
        public abstract void AddData(byte pos, byte[] data);
        #endregion
    }
}
