using System;
using System.Collections.Generic;
using System.Text;
using System.ComponentModel;
using Bwg.Burner;

namespace Bwg.CreateAudioDisk
{
    class CDTextDataStringConverter : TypeConverter
    {
        public CDTextDataStringConverter()
        {
        }

        public override bool CanConvertFrom(ITypeDescriptorContext context, Type sourceType)
        {
            if (sourceType == typeof(CDTextDataString) || sourceType == typeof(string))
                return true ;

            return base.CanConvertFrom(context, sourceType);
        }

        public override bool CanConvertTo(ITypeDescriptorContext context, Type destinationType)
        {
            if (destinationType == typeof(CDTextDataString))
                return true ;

            return base.CanConvertTo(context, destinationType);
        }

        public override object ConvertFrom(ITypeDescriptorContext context, System.Globalization.CultureInfo culture, object value)
        {
            if (value is CDTextDataString)
                return value.ToString();
            else if (value is string)
                return new CDTextDataString((string)value, null);

            return base.ConvertFrom(context, culture, value);
        }

        public override object ConvertTo(ITypeDescriptorContext context, System.Globalization.CultureInfo culture, object value, Type destinationType)
        {
            if (destinationType == typeof(CDTextDataString) && value is string)
                return new CDTextDataString((string)value, null);

            else if (destinationType == typeof(string) && value is CDTextDataString)
                return value.ToString();

            return base.ConvertTo(context, culture, value, destinationType);
        }

        public override bool IsValid(ITypeDescriptorContext context, object value)
        {
            if (value is string)
                return true;

            return base.IsValid(context, value);
        }
    }
}
