using System;
using System.Collections.Generic;
using System.Text;
using System.ComponentModel;
using Bwg.Burner;

namespace Bwg.CreateAudioDisk
{
    class CDTextTrackProps
    {
        private CDTextDataString m_title;
        private CDTextDataString m_performer;
        private CDTextDataString m_songwriter;
        private CDTextDataString m_composer;
        private CDTextDataString m_arranger;
        private CDTextDataString m_message;

        [Description("The title of this track")]
        [TypeConverter(typeof(CDTextDataStringConverter))]
        public CDTextDataString Title
        {
            get { return m_title; }
            set { m_title = value; }
        }

        [Description("The artist that performed this track")]
        [TypeConverter(typeof(CDTextDataStringConverter))]
        public CDTextDataString Performer
        {
            get { return m_performer; }
            set { m_performer = value; }
        }

        [Description("The songwriter for this track")]
        [TypeConverter(typeof(CDTextDataStringConverter))]
        public CDTextDataString Songwriter
        {
            get { return m_songwriter; }
            set { m_songwriter = value; }
        }

        [Description("The composer for this track")]
        [TypeConverter(typeof(CDTextDataStringConverter))]
        public CDTextDataString Composer
        {
            get { return m_composer; }
            set { m_composer = value; }
        }

        [Description("The arranger for this track")]
        [TypeConverter(typeof(CDTextDataStringConverter))]
        public CDTextDataString Arranger
        {
            get { return m_arranger; }
            set { m_arranger = value; }
        }

        [Description("A message associated with this track")]
        [TypeConverter(typeof(CDTextDataStringConverter))]
        public CDTextDataString Message
        {
            get { return m_message; }
            set { m_message = value; }
        }

        public CDTextTrackProps()
        {
            m_arranger = new CDTextDataString();
            m_composer = new CDTextDataString();
            m_message = new CDTextDataString();
            m_performer = new CDTextDataString();
            m_songwriter = new CDTextDataString();
            m_title = new CDTextDataString();
        }
    }
}
