//
// BwgBurn - CD-R/CD-RW/DVD-R/DVD-RW burning program for Windows XP
// 
// Copyright (C) 2006 by Jack W. Griffin (butchg@comcast.net)
//
// This program is free software; you can redistribute it and/or modify 
// it under the terms of the GNU General Public License as published by 
// the Free Software Foundation; either version 2 of the License, or 
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but 
// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
// or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
// for more details.
//
// You should have received a copy of the GNU General Public License along 
// with this program; if not, write to the 
//
// Free Software Foundation, Inc., 
// 59 Temple Place, Suite 330, 
// Boston, MA 02111-1307 USA
//
using System;
using System.Collections.Generic;
using System.Text;
using Bwg.Burner;

namespace Bwg.DiskImage
{
    internal class TrackInfo
    {
        #region private members
        private TrackBurnImage.TrackType m_type;
        private int m_number;
        private int m_start;
        private int m_size;
        #endregion

        #region constructor
        public TrackInfo(TrackBurnImage.TrackType type, int number, int start, int size)
        {
            m_type = type;
            m_number = number;
            m_start = start;
            m_size = size;
        }
        #endregion

        #region public properties
        public TrackBurnImage.TrackType TrackType
        {
            get
            {
                return m_type;
            }
        }

        public int Number
        {
            get
            {
                return m_number;
            }
        }

        public int Start
        {
            get
            {
                return m_start;
            }
        }

        public int Size
        {
            get
            {
                return m_size;
            }
        }

        public int SectorSize
        {
            get
            {
                int size = 0;

                switch (m_type)
                {
                    case TrackBurnImage.TrackType.Audio:
                        size = 2352;
                        break;

                    case TrackBurnImage.TrackType.Data_Mode_1:
                        size = 2048;
                        break;

                    case TrackBurnImage.TrackType.Data_Mode_2_Formless:
                        size = 2336;
                        break;

                    case TrackBurnImage.TrackType.Data_Mode_2_Form_1:
                        size = 2048;
                        break;

                    case TrackBurnImage.TrackType.Data_Mode_2_Form_2:
                        size = 2324;
                        break;
                }
                return size;
            }
        }
        #endregion
    }
}
