using System;
using System.Collections.Generic;
using System.Text;

namespace Bwg.DvdMaster
{
    /// <summary>
    /// This command list is a set of eight bit instructions that can be executed
    /// by the DVD virtual machine.
    /// </summary>
    public class DvdCommandList
    {
        #region private member variables
        /// <summary>
        /// The DVD virtual machine commands encoded into byte form
        /// </summary>
        private byte[] m_commands;
        #endregion

        #region constructor
        /// <summary>
        /// Create a new command list with no data
        /// </summary>
        public DvdCommandList()
        {
            m_commands = new byte[0];
        }
        #endregion

        #region public properties
        /// <summary>
        /// This property returns the number of bytes of encoded command data
        /// </summary>
        public int Count
        {
            get { return m_commands.GetLength(0); }
        }
        #endregion

        #region public methods
        /// <summary>
        /// This method returns a string representation of the command set.  This method basically
        /// disassembles the commands stored.
        /// </summary>
        /// <returns>a string representing the stored program</returns>
        public override string ToString()
        {
            return string.Empty;
        }
        #endregion
    }
}
