using System;
using System.Collections.Generic;
using System.Text;

namespace Bwg.DvdMaster
{
    public class DvdDataStructure
    {
        #region public methods
        public string ExtractString(byte[] data, ref int offset, int len)
        {
            string str = Encoding.ASCII.GetString(data, offset, len);
            offset += len;

            return str;
        }

        public ulong ExtractUInt8(byte[] data, ref int offset)
        {
            ulong ret = 0;

            ret |= (ulong)((ulong)data[offset++] << 56);
            ret |= (ulong)((ulong)data[offset++] << 48);
            ret |= (ulong)((ulong)data[offset++] << 40);
            ret |= (ulong)((ulong)data[offset++] << 32);
            ret |= (ulong)((ulong)data[offset++] << 24);
            ret |= (ulong)((ulong)data[offset++] << 16);
            ret |= (ulong)((ulong)data[offset++] << 8);
            ret |= (ulong)((ulong)data[offset++] << 0);

            return ret;
        }

        public uint ExtractUInt4(byte[] data, ref int offset)
        {
            uint ret = 0;

            ret |= (uint)(data[offset++] << 24);
            ret |= (uint)(data[offset++] << 16);
            ret |= (uint)(data[offset++] << 8);
            ret |= (uint)(data[offset++] << 0);

            return ret;
        }

        public ushort ExtractUInt2(byte[] data, ref int offset)
        {
            ushort ret = 0;

            ret |= (ushort)(data[offset++] << 8);
            ret |= (ushort)(data[offset++] << 0);

            return ret;
        }
        #endregion
    }
}
