using System;
using System.Collections.Generic;
using System.Text;

namespace Bwg.DvdMaster
{
    /// <summary>
    /// This class is a part of title object.  This object is a set of consecutively
    /// numbered programs.
    /// </summary>
    public class DvdPartOfTitle
    {
        #region private member variables
        /// <summary>
        /// The program chain this PTT belongs to
        /// </summary>
        private DvdProgramChain m_program_chain;

        /// <summary>
        /// The list of programs that make up the part of title object
        /// </summary>
        private IList<DvdProgram> m_programs;
        #endregion

        #region constructor
        /// <summary>
        /// Create a new empty part of title.
        /// </summary>
        public DvdPartOfTitle(DvdProgramChain chain)
        {
            m_program_chain = chain;
            m_programs = new List<DvdProgram>();
        }
        #endregion
    }
}
