using System;
using System.Collections.Generic;
using System.Text;
using System.ComponentModel ;

namespace Bwg.DvdMaster
{
    public class VMGM_PGCI_UT : DvdDataStructure
    {
        #region private member variables
        private ushort m_number_of_language_units;
        private uint m_address_of_last_byte;
        private VMGM_PGCI_UT_Language_Unit[] m_language_units;
        #endregion

        #region construtors
        public VMGM_PGCI_UT()
        {
        }

        public VMGM_PGCI_UT(byte[] data)
        {
            int offset = 0;

            m_number_of_language_units = ExtractUInt2(data, ref offset);
            // Padding 2 bytes
            offset += 2;

            m_address_of_last_byte = ExtractUInt4(data, ref offset);

            m_language_units = new VMGM_PGCI_UT_Language_Unit[m_number_of_language_units];
            for (int i = 0; i < m_number_of_language_units; i++)
            {
                VMGM_PGCI_UT_Language_Unit unit = new VMGM_PGCI_UT_Language_Unit(data, ref offset);
                m_language_units[i] = unit;
            }
        }
        #endregion

        #region public properties
        [Description("Number Of Language Units on this disc")]
        public ushort NumberOfLanguageUnits
        {
            get { return m_number_of_language_units; }
        }

        [Description("Address of last byte")]
        public uint AddressOfLastByte
        {
            get { return m_address_of_last_byte; }
        }

        public VMGM_PGCI_UT_Language_Unit this[int index]
        {
            get { return m_language_units[index]; }
        }
        #endregion
    }
}
