using System;
using System.Collections.Generic;
using System.Text;

namespace Bwg.DvdMaster
{
    public class VMGM_PGCI_UT_Language_Unit : DvdDataStructure
    {
        #region private member variables
        private ushort m_language_code;
        private byte m_language_code_ext;
        private byte m_menu_existance_flag;
        private uint m_language_unit_start;
        private ushort m_number_of_menus;
        private uint m_address_of_last_byte;
        private VMGM_PGCI_UT_Language_Unit_Menu[] m_menus;
        #endregion

        #region constructors
        public VMGM_PGCI_UT_Language_Unit()
        {
        }

        public VMGM_PGCI_UT_Language_Unit(byte[] data, ref int offset)
        {
            m_language_code = ExtractUInt2(data, ref offset) ;
            m_language_code_ext = data[offset++] ;
            m_menu_existance_flag = data[offset++] ;
            m_language_unit_start = ExtractUInt4(data, ref offset) ;
            m_number_of_menus = ExtractUInt2(data, ref offset) ;
            m_address_of_last_byte = ExtractUInt4(data, ref offset) ;

            //
            // Assert that the unit_start is within the array
            //
            if (m_language_unit_start < data.GetLength(0))
            {
                m_menus = new VMGM_PGCI_UT_Language_Unit_Menu[m_number_of_menus] ;
                offset = (int)m_language_unit_start ;
                for (int i = 0; i < m_number_of_menus; i++)
                    m_menus[i] = new VMGM_PGCI_UT_Language_Unit_Menu(data, ref offset);            
            }
        }
        #endregion

        #region public properties
        public ushort LanguageCode
        {
            get { return m_language_code; }
        }

        public byte LanguageCodeExt
        {
            get { return m_language_code_ext; }
        }

        public byte MenuExistanceFlag
        {
            get { return m_menu_existance_flag; }
        }

        public uint LanguageUnitStart
        {
            get { return m_language_unit_start; }
        }

        public ushort NumberOfMenus
        {
            get { return m_number_of_menus; }
        }

        public uint AddressOfLastByte
        {
            get { return m_address_of_last_byte; }
        }


        public VMGM_PGCI_UT_Language_Unit_Menu this[int index]
        {
            get { return m_menus[index]; }
        }
        #endregion
    }
}
