using System;
using System.Collections.Generic;
using System.Text;

namespace Bwg.DvdMaster
{
    public class VMGM_PGCI_UT_Language_Unit_Menu : DvdDataStructure
    {
        #region private member variables
        private byte m_menu_type;
        private byte m_menu_category;
        private ushort m_parental_id;
        private uint m_pgc_unit_start_byte;
        #endregion

        #region constructor
        public VMGM_PGCI_UT_Language_Unit_Menu()
        {
        }

        public VMGM_PGCI_UT_Language_Unit_Menu(byte[] data, ref int offset)
        {
            m_menu_type = data[offset++];
            m_menu_category = data[offset++];
            m_parental_id = ExtractUInt2(data, ref offset);
            m_pgc_unit_start_byte = ExtractUInt4(data, ref offset);
        }
        #endregion

        #region public properties
        public byte MenuType
        {
            get { return m_menu_type; }
        }

        public byte MenuCategory
        {
            get { return m_menu_category; }
        }

        public ushort ParentalId
        {
            get { return m_parental_id; }
        }

        public uint PgcUnitStartByte
        {
            get { return m_pgc_unit_start_byte; }
        }
        #endregion
    }
}
