using System;
using System.Collections.Generic;
using System.Text;
using System.ComponentModel ;

namespace Bwg.DvdMaster
{
    public class VMG_PTT_SRPT_Title_Desc : DvdDataStructure
    {
        #region private member variables
        private byte m_playback_type;
        private byte m_number_of_angles;
        private ushort m_number_of_chapters;
        private ushort m_parental_management_mask;
        private byte m_video_title_set;
        private byte m_title_number;
        private uint m_video_title_set_sector_adress;
        #endregion

        #region constructor
        public VMG_PTT_SRPT_Title_Desc(byte[] data, ref int offset)
        {
            m_playback_type = data[offset++];
            m_number_of_angles = data[offset++];
            m_number_of_chapters = ExtractUInt2(data, ref offset);
            m_parental_management_mask = ExtractUInt2(data, ref offset);
            m_video_title_set = data[offset++];
            m_title_number = data[offset++];
            m_video_title_set_sector_adress = ExtractUInt4(data, ref offset);
        }
        #endregion

        #region public properties
        [Description("Type of playback")]
        public byte PlaybackType
        {
            get { return m_playback_type; }
        }

        public byte NumberOfAngles
        {
            get { return m_number_of_angles; }
        }

        public ushort NumberOfChapters
        {
            get { return m_number_of_chapters; }
        }

        public ushort ParentalManagementMask
        {
            get { return m_parental_management_mask; }
        }

        public byte VideoTitleSet
        {
            get { return m_video_title_set; }
        }

        public byte TitleNumber
        {
            get { return m_title_number; }
        }

        public uint VideoTitleSectorAddress
        {
            get { return m_video_title_set_sector_adress; }
        }

        #endregion
    }
}
