//
// BwgBurn - CD-R/CD-RW/DVD-R/DVD-RW burning program for Windows XP
// 
// Copyright (C) 2006 by Jack W. Griffin (butchg@comcast.net)
//
// This program is free software; you can redistribute it and/or modify 
// it under the terms of the GNU General Public License as published by 
// the Free Software Foundation; either version 2 of the License, or 
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but 
// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
// or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
// for more details.
//
// You should have received a copy of the GNU General Public License along 
// with this program; if not, write to the 
//
// Free Software Foundation, Inc., 
// 59 Temple Place, Suite 330, 
// Boston, MA 02111-1307 USA
//

using System;
using System.Collections.Generic;
using System.Text;

namespace Bwg.Isofs
{
    /// <summary>
    /// This class is the argument for the event that is triggered when a 
    /// directory is added to a disk image
    /// </summary>
    public class AddingDirectoryEventArgs : EventArgs
    {
        /// <summary>
        /// The name of the directory added on the image
        /// </summary>
        public readonly DiskImageDirectory Root ;

        /// <summary>
        /// The name of the directory added on the local file system.
        /// </summary>
        public readonly DiskImageDirectory Dir;

        /// <summary>
        /// Create arguemnt for an event handler that tells what directory is being created
        /// and where it is being created.
        /// </summary>
        /// <param name="root">the destination for the new directory</param>
        /// <param name="dir">the new directory</param>
        public AddingDirectoryEventArgs(DiskImageDirectory root, DiskImageDirectory dir)
        {
            Root = root;
            Dir = dir;
        }
    }
}
