//
// BwgBurn - CD-R/CD-RW/DVD-R/DVD-RW burning program for Windows XP
// 
// Copyright (C) 2006 by Jack W. Griffin (butchg@comcast.net)
//
// This program is free software; you can redistribute it and/or modify 
// it under the terms of the GNU General Public License as published by 
// the Free Software Foundation; either version 2 of the License, or 
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but 
// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
// or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
// for more details.
//
// You should have received a copy of the GNU General Public License along 
// with this program; if not, write to the 
//
// Free Software Foundation, Inc., 
// 59 Temple Place, Suite 330, 
// Boston, MA 02111-1307 USA
//

using System;
using System.Collections.Generic;
using System.Text;

namespace Bwg.Isofs
{
    /// <summary>
    /// This class is the arguments for the event that is fired when a file is
    /// added to the disk image.
    /// </summary>
    public class AddingFileEventArgs : EventArgs
    {
        /// <summary>
        /// The name of the file in the local file system.
        /// </summary>
        public readonly string LocalFileName;

        /// <summary>
        /// Create a new argument class
        /// </summary>
        /// <param name="fs">the name of the newly added file in the local file system</param>
        public AddingFileEventArgs(string fs)
        {
            LocalFileName = fs;
        }
    }
}
