//
// BwgBurn - CD-R/CD-RW/DVD-R/DVD-RW burning program for Windows XP
// 
// Copyright (C) 2006 by Jack W. Griffin (butchg@comcast.net)
//
// This program is free software; you can redistribute it and/or modify 
// it under the terms of the GNU General Public License as published by 
// the Free Software Foundation; either version 2 of the License, or 
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but 
// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
// or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
// for more details.
//
// You should have received a copy of the GNU General Public License along 
// with this program; if not, write to the 
//
// Free Software Foundation, Inc., 
// 59 Temple Place, Suite 330, 
// Boston, MA 02111-1307 USA
//
using System;
using System.Collections.Generic;
using System.Text;
using System.Diagnostics;

namespace Bwg.Isofs
{
    class AnchorVolumeDescriptorPointerTask : SequencedUDFDescriptor
    {
        public TaskGroup MainVolumeDescriptorSequence;
        public TaskGroup ReserveVolumeDescriptorSequence;

        public AnchorVolumeDescriptorPointerTask(int seqno)
            : base(seqno)
        {
            MainVolumeDescriptorSequence = null;
            ReserveVolumeDescriptorSequence = null;
        }

        public override bool UpdateLayout(DiskImageCreator creator, DiskInfo info)
        {
            info.CurrentBlock++;
            return true;
        }

        public override bool Write(DiskImageCreator creator, DiskInfo info, IsoWriteStream strm)
        {
            byte[] data = new byte[0];

            Debug.Assert(MainVolumeDescriptorSequence != null);
            Debug.Assert(ReserveVolumeDescriptorSequence != null);

            AddExtentAD(ref data, MainVolumeDescriptorSequence.ExtentAd);
            AddExtentAD(ref data, ReserveVolumeDescriptorSequence.ExtentAd);
            AddZeros(ref data, 480);

            return WriteDescriptor(strm, UdfDescriptorTask.AnchorVolumeDescriptorPointer, 2, data);
        }
    }
}
