//
// BwgBurn - CD-R/CD-RW/DVD-R/DVD-RW burning program for Windows XP
// 
// Copyright (C) 2006 by Jack W. Griffin (butchg@comcast.net)
//
// This program is free software; you can redistribute it and/or modify 
// it under the terms of the GNU General Public License as published by 
// the Free Software Foundation; either version 2 of the License, or 
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but 
// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
// or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
// for more details.
//
// You should have received a copy of the GNU General Public License along 
// with this program; if not, write to the 
//
// Free Software Foundation, Inc., 
// 59 Temple Place, Suite 330, 
// Boston, MA 02111-1307 USA
//
using System;
using System.Collections.Generic;
using System.Text;
using System.Diagnostics;

namespace Bwg.Isofs
{
    class FileSetDescriptorTask : UdfDescriptorTask
    {
        public UDFDirectoryAndFileTask FilesAndDirectories;

        public FileSetDescriptorTask()
        {
            FilesAndDirectories = null;
        }

        public override bool UpdateLayout(DiskImageCreator creator, DiskInfo info)
        {
            info.CurrentBlock++;
            return true;
        }

        public override bool Write(DiskImageCreator creator, DiskInfo info, IsoWriteStream strm)
        {
            byte[] data = new byte[0];

            Debug.Assert(FilesAndDirectories != null);
            
            DiskImageDirectory root = creator.RootDirectory ;
            long loc = root.GetDirectoryLocation(DiskImageDirectory.DirectoryLocationType.UdfFileEntry).Location;
            ExtentAd rootdir = new ExtentAd(loc, 2048);

            AddDateTime(ref data, creator.Settings.UdfSettings.CreationDateTime);           // RecordingDateandTime
            AddShort(ref data, 3);                                                          // InterchangeLevel
            AddShort(ref data, 3);                                                          // MaximumInterchangeLevel
            AddInt(ref data, 1);                                                            // CharacterSetList
            AddInt(ref data, 1);                                                            // MaximumCharacterSetList
            AddInt(ref data, 0);                                                            // FileSetNumber
            AddInt(ref data, 0);                                                            // FileSetDescriptorNumber
            AddCharset(ref data, UdfDescriptorTask.OSTACompressedUnicode);                  // LogicalVolumeIdentifierCharSet
            AddDString(ref data, creator.Settings.UdfSettings.VolumeIdentifier, 128, 16);   // LogicalVolumeIdentifier
            AddCharset(ref data, UdfDescriptorTask.OSTACompressedUnicode);                  // FileSetCharacterSet
            AddDString(ref data, creator.Settings.UdfSettings.VolumeIdentifier, 32, 16);    // FileSetIdentifier
            AddDString(ref data, string.Empty, 32, 16);                                     // CopyrightFileIdentifier
            AddDString(ref data, string.Empty, 32, 16);                                     // AbstractFileIdentifier
            AddLongExtentAD(ref data, rootdir, true);                                       // RootDirectoryICB
            AddRegid(ref data, RegIdType.DomainID_1_02_2) ;                                 // DomainIdentifier
            AddLongExtentAD(ref data, ExtentAd.Empty, true) ;                               // NextExtent
            AddZeros(ref data, 48) ;
 
            return WriteDescriptor(strm, UdfDescriptorTask.FileSetDescriptor, 2, data);
        }
    }
}
