//
// BwgBurn - CD-R/CD-RW/DVD-R/DVD-RW burning program for Windows XP
// 
// Copyright (C) 2006 by Jack W. Griffin (butchg@comcast.net)
//
// This program is free software; you can redistribute it and/or modify 
// it under the terms of the GNU General Public License as published by 
// the Free Software Foundation; either version 2 of the License, or 
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but 
// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
// or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
// for more details.
//
// You should have received a copy of the GNU General Public License along 
// with this program; if not, write to the 
//
// Free Software Foundation, Inc., 
// 59 Temple Place, Suite 330, 
// Boston, MA 02111-1307 USA
//
using System;
using System.Collections.Generic;
using System.Text;

namespace Bwg.Isofs
{
    /// <summary>
    /// This class represents the args that describe a change to the image tree
    /// </summary>
    public class ImageChangedEventArgs : EventArgs
    {
        /// <summary>
        /// The type of change that occurred
        /// </summary>
        public enum ChangeType
        {
            /// <summary>
            /// Added a new node (currently not used)
            /// </summary>
            Added,

            /// <summary>
            /// Removed a node
            /// </summary>
            Removed,

            /// <summary>
            /// Renamed a node
            /// </summary>
            Renamed
        } ;

        /// <summary>
        /// This element that changed
        /// </summary>
        public readonly DiskImageElement Element;

        /// <summary>
        /// The type of change that occured
        /// </summary>
        public readonly ChangeType Change;

        /// <summary>
        /// The constructor for this type
        /// </summary>
        /// <param name="elem">the element that changed</param>
        /// <param name="t">the type of change</param>
        public ImageChangedEventArgs(DiskImageElement elem, ChangeType t)
        {
            Element = elem;
            Change = t;
        }
    }
}
