//
// BwgBurn - CD-R/CD-RW/DVD-R/DVD-RW burning program for Windows XP
// 
// Copyright (C) 2006 by Jack W. Griffin (butchg@comcast.net)
//
// This program is free software; you can redistribute it and/or modify 
// it under the terms of the GNU General Public License as published by 
// the Free Software Foundation; either version 2 of the License, or 
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but 
// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
// or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
// for more details.
//
// You should have received a copy of the GNU General Public License along 
// with this program; if not, write to the 
//
// Free Software Foundation, Inc., 
// 59 Temple Place, Suite 330, 
// Boston, MA 02111-1307 USA
//
using System;
using System.Collections.Generic;
using System.Text;

namespace Bwg.Isofs
{
    class ImplementationUseVolumeDescriptorTask : SequencedUDFDescriptor
    {
        public ImplementationUseVolumeDescriptorTask(int seqno) : base(seqno)
        {
        }

        public override bool UpdateLayout(DiskImageCreator creator, DiskInfo info)
        {
            info.CurrentBlock++;
            return true;
        }

        public override bool Write(DiskImageCreator creator, DiskInfo info, IsoWriteStream strm)
        {
            byte[] data = new byte[0];

            AddInt(ref data, VolumeDescriptorSequenceNumber);                               // Volume Descriptor Sequence Number
            AddRegid(ref data, RegIdType.UDFIdentifier);                                    // UDF Identifier

            // Implementation USE Area
            AddCharset(ref data, UdfDescriptorTask.OSTACompressedUnicode);                  // LVICharset
            AddDString(ref data, creator.Settings.UdfSettings.VolumeIdentifier, 128, 16);   // Logical Volume Identifier
            AddZeros(ref data, 36);                                                         // LVInfo1
            AddZeros(ref data, 36);                                                         // LVInfo2
            AddZeros(ref data, 36);                                                         // LVInfo3
            AddRegid(ref data, RegIdType.DeveloperID_1);                                    // Implementation ID
            AddZeros(ref data, 128);

            return WriteDescriptor(strm, UdfDescriptorTask.ImplementationUseVolumeDescriptor, 2, data);
        }
    }
}
