//
// BwgBurn - CD-R/CD-RW/DVD-R/DVD-RW burning program for Windows XP
// 
// Copyright (C) 2006 by Jack W. Griffin (butchg@comcast.net)
//
// This program is free software; you can redistribute it and/or modify 
// it under the terms of the GNU General Public License as published by 
// the Free Software Foundation; either version 2 of the License, or 
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but 
// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
// or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
// for more details.
//
// You should have received a copy of the GNU General Public License along 
// with this program; if not, write to the 
//
// Free Software Foundation, Inc., 
// 59 Temple Place, Suite 330, 
// Boston, MA 02111-1307 USA
//

using System;
using System.Collections.Generic;
using System.Text;

namespace Bwg.Isofs
{
    /// <summary>
    /// This class contains the arguments that are sent when a 
    /// name change event occurs in a disk image.
    /// </summary>
    public class NameChangeEventArgs : EventArgs
    {
        /// <summary>
        /// The new name for the elemnet
        /// </summary>
        public readonly string NewName ;

        /// <summary>
        /// The old name for the element
        /// </summary>
        public readonly string OldName ;

        /// <summary>
        /// Construct the name change event arguments
        /// </summary>
        /// <param name="newname">the new name</param>
        /// <param name="oldname">the old name</param>
        public NameChangeEventArgs(string newname, string oldname)
        {
            NewName = newname;
            OldName = oldname;
        }
    }
}
